# pyground. A collection of utility and wrapper classes
# Copyright (C) 2004 David Soulayrol <dsoulayrol@free.fr>
#
# This file is part of pyground.
#
# pyground is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
[TODO: to be wrote}
"""

import logging

from ground.util.singleton import Singleton

DEBUG = logging.DEBUG
INFO = logging.INFO
WARNING = logging.WARNING
ERROR = logging.ERROR
CRITICAL = logging.CRITICAL

# TODO: implement a logger capable of reading XML configurations.
class Logger(Singleton):
    """A wrapper around the logging module.

    This Logger class is a singleton.
    """
    def __init__(self, aName, aLevel):
        if self.__dict__ == {}:
            self._logger = logging.getLogger(aName)
            lHandler = logging.FileHandler('./' + aName + '.log')
            lFormatter = logging.Formatter(
                '%(asctime)s %(levelname)s %(message)s')
            lHandler.setFormatter(lFormatter)
            self._logger.addHandler(lHandler) 
            self._logger.setLevel(aLevel)


    def debug(cls, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].debug(
            aMessage, *args, **kwargs)
    debug = classmethod(debug)


    def info(cls, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].info(
            aMessage, *args, **kwargs)
    info = classmethod(info)


    def warning(cls, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].warning(
            aMessage, *args, **kwargs)
    warning = classmethod(warning)


    def error(cls, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].error(
            aMessage, *args, **kwargs)        
    error = classmethod(error)


    def critical(cls, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].critical(
            aMessage, *args, **kwargs)
    critical = classmethod(critical)


    def log(cls, aLevel, aMessage, *args, **kwargs):
        Logger.__dict__['_Logger__shared_state']['_logger'].log(
            aLevel, aMessage, *args, **kwargs)
    log = classmethod(log)
