# pyground. A collection of utility and wrapper classes
# Copyright (C) 2004 David Soulayrol <dsoulayrol@free.fr>
#
# This file is part of pyground.
#
# pyground is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
Implementations of the Singleton pattern.
[TODO: to be wrote}

see http://c2.com/cgi/wiki?PythonSingleton.
"""

class Singleton(object):
    """A Singleton factory.

    This class should be subclassed by any class pretending act as the
    singleton design pattern. Subclasses should ensure that their __init__
    method is safe when called repeatedly on the one and only class instance.
    
    see Python in a Nutshell (Alex Martelli).
    """
    __instances = {}
    
    def __new__(cls, *args, **kwds):
        if not cls.__instances.has_key(cls):
            cls.__instances[cls] = object.__new__(cls)
        return cls.__instances[cls]
    

class Borg:
    """A sort of Singleton implementation.
    
    All instances of this class share the same attributes dictionnary.
    
    see http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/66531.
    """
    __shared_state = {}
    def __init__(self):
        self.__dict__ = self.__shared_state
